<template>
  <div class="column q-pa-md items-center">
    <div class="col-fit column">
      <q-file
        v-model="q_selected_file"
        @update:modelValue="onQFileSelected()"
        :label="filter + ' only'"
        filled
        style="min-width:300px;max-width:1000px;"
        :accept="filter"
        @rejected="onFileRejected"
        :filter="filter"
      />
    </div>
    <div class="col" v-if="q_selected_file != undefined">
      <br>
      <b>Name:</b><br>{{ q_selected_file.name }}<br><br>
      <b>Directory:</b><br>{{ q_selected_file.path }}
    </div>
  </div>
</template>

<script lang="ts">
import { ref, defineComponent, onMounted } from 'vue';
import { useQuasar } from 'quasar';

export default defineComponent({
  name: 'FilePicker',
  emits: ['update:selected_file'],
  components: {
  },
  props: {
    filter: String,
    selected_file: Object,
  },
  setup (props, { emit }) {
    const q_selected_file = ref<Record<string,unknown>>();

    onMounted(() => {
      q_selected_file.value = props.selected_file;
    });

    const onQFileSelected = ((): void => {
      emit('update:selected_file', q_selected_file.value);
    });

    const $q = useQuasar();
    const onFileRejected = ((rejectedEntries: Array<unknown>): void => {
      // Notify plugin needs to be installed
      // https://quasar.dev/quasar-plugins/notify#Installation
      $q.notify({
        type: 'negative',
        message: `${rejectedEntries.length} file(s) did not pass validation constraints`
      })
    });

    return {
      q_selected_file,
      onQFileSelected,

      onFileRejected,
    };
  },
});

</script>
